/**
 *  Copyright © 2026, Luis Andrés Lange <https://javacomm.net>
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.protocol;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import java.lang.reflect.Type;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;



public class CBlockSerializer implements JsonSerializer<CBlock> {

  private final static Logger log = LogManager.getLogger(CBlockSerializer.class);

  @Override
  public JsonElement serialize(CBlock cblock, Type type, JsonSerializationContext context) {

    JsonObject jsonObject = new JsonObject();

    if (cblock.getPseudoPassword() == null) {
      log.fatal("Protokollfehler: CBlock, das Attribut PPASSWORD ist nicht gesetzt.");
      throw new JsonParseException("Protokollfehler: CBlock, das Attribut PPASSWORD ist nicht gesetzt.");
    }

    if (cblock.getTimestamp() == null) {
      log.fatal("Protokollfehler: CBlock, das Attribut TIMESTAMP ist nicht gesetzt.");
      throw new JsonParseException("Protokollfehler: CBlock, das Attribut TIMESTAMP ist nicht gesetzt.");
    }

    jsonObject.add(CBlock.PPASSWORD, context.serialize(cblock.getPseudoPassword()));
    jsonObject.add(CBlock.TIMESTAMP, context.serialize(cblock.getTimestamp()));

    return jsonObject;

  }

}
